#include <bits/stdc++.h>
using namespace std;
ifstream f1("bai1_16.inp");
ofstream f2("bai1_16.out");
long long snt[100000],q=0,n;
void nt(long long a,long long i=2)
{

    if(a>1)
    {
        if(a%i==0){
            snt[q]=i;
            q++;
            nt(a/i,2);
        }
        else{
            nt(a,i+1);
        }
    }
}
int main()
{
    f1>>n;
    nt(n,2);
    f2<<snt[q-1];
    f1.close();
    f2.close();
}
